/*  alltest.c -- Small program to test the alltel module
    Copyright (C) 2000  Shane Wegner

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author, please write to Shane Wegner, 10425 140B st,
    Surrey BC, V3T 4N9 Canada or email shane@cm.nu. */

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/alltel.h>

int main(int ARGC, char **ARGV)
{
struct alltel_event al_event;
int fd, retval;
fd_set rfd;
if ((fd = open("/dev/alltel", O_RDONLY | O_NONBLOCK)) == -1)
{
fprintf(stderr, "Can't open /dev/alltel\n");
return 1;
}
while(1)
{
FD_ZERO(&rfd);
FD_SET(fd, &rfd);
retval = select(fd + 1, &rfd, NULL, NULL, NULL);
if (retval && FD_ISSET(fd, &rfd))
{
read(fd, &al_event, sizeof(struct alltel_event));
printf("Event received with al_time = %ld %ld\n", al_event.al_time.tv_sec, al_event.al_time.tv_usec);
if (al_event.al_isready)
printf("Device is ready\n");
else
printf("Device is not ready\n");
if (al_event.al_dtmf)
printf("DTMF digit = %c\n", al_event.al_digit);
if (al_event.al_loopbreak)
printf("loopbreak bit is set\n");
if (al_event.al_offhook)
printf("offhook bit is set\n");
if (al_event.al_dtmf && al_event.al_digit == '*')
break;
printf("\n");
}
}
close(fd);
return 0;
}
